"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EmojiPickerPopover = exports.EmojiPicker = void 0;
const react_1 = __importStar(require("react"));
const react_2 = require("@chakra-ui/react");
const data_1 = __importDefault(require("@emoji-mart/data"));
const react_3 = require("@strata-foundation/react");
const chat_1 = require("@strata-foundation/chat");
const contexts_1 = require("../contexts");
const MyFlex_1 = require("./MyFlex");
const EmojiPicker = (props) => {
    const ref = (0, react_1.useRef)();
    const showEmojis = (0, react_1.useRef)(true);
    (0, react_1.useEffect)(() => {
        if (showEmojis.current) {
            showEmojis.current = false;
            // @ts-ignore
            Promise.resolve().then(() => __importStar(require("emoji-mart"))).then((EmojiMart) => {
                new EmojiMart.Picker(Object.assign(Object.assign({}, props), { 
                    // @ts-ignore
                    data: data_1.default,
                    ref }));
            });
        }
        ref.current.children[0] &&
            ref.current.children[0].shadowRoot
                .querySelector('input[type="search"]')
                .focus();
    }, [props, ref]);
    return react_1.default.createElement("div", { ref: ref });
};
exports.EmojiPicker = EmojiPicker;
const EmojiPickerPopover = ({ chatKey }) => {
    const [emoji, setEmoji] = (0, react_1.useState)();
    const { referenceMessageId, hidePicker } = (0, contexts_1.useEmojis)();
    const rgbBackground = (0, react_2.useColorModeValue)("243 244 246", "32 41 55");
    const rgbColor = (0, react_2.useColorModeValue)("white", "black");
    const rgbInput = (0, react_2.useColorModeValue)("255 255 255", "56 63 75");
    const colorBorder = (0, react_2.useColorModeValue)("#e4e7eb", "");
    const { handleErrors } = (0, react_3.useErrorHandler)();
    const { sendMessage, error } = (0, contexts_1.useSendMessage)();
    handleErrors(error);
    const reset = (0, react_1.useCallback)(() => {
        setEmoji(undefined);
        hidePicker();
    }, [hidePicker, setEmoji]);
    const preventClickBehavior = (e) => {
        e.preventDefault();
        e.stopPropagation();
    };
    (0, react_1.useEffect)(() => {
        if (emoji) {
            sendMessage({
                message: {
                    type: chat_1.MessageType.React,
                    emoji: emoji.native,
                    referenceMessageId,
                },
            });
            reset();
        }
    }, [emoji, referenceMessageId, reset, sendMessage]);
    return (react_1.default.createElement(MyFlex_1.Flex, { w: !!referenceMessageId ? "full" : "none", h: !!referenceMessageId ? "full" : "none", position: "absolute", top: "0", right: "0", zIndex: "1", justifyContent: "end", onClick: reset },
        react_1.default.createElement(react_2.Fade, { in: !!referenceMessageId },
            react_1.default.createElement(MyFlex_1.Flex, { display: !!referenceMessageId ? "flex" : "none", onClick: preventClickBehavior, sx: {
                    "--rgb-color": rgbColor,
                    "--rgb-background": rgbBackground,
                    "--rgb-input": rgbInput,
                    "--color-border": colorBorder,
                } },
                react_1.default.createElement(exports.EmojiPicker
                // @ts-ignore
                , { 
                    // @ts-ignore
                    onEmojiSelect: setEmoji })))));
};
exports.EmojiPickerPopover = EmojiPickerPopover;
//# sourceMappingURL=EmojiPicker.js.map