"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Flex = void 0;
/**
 * The chakra UI flex uses styles = {...} which creates a new object and causes rerenders every time the parent rerenders.
 * This is more performant
*/
const system_1 = require("@chakra-ui/system");
const utils_1 = require("@chakra-ui/utils");
const React = __importStar(require("react"));
/**
 * React component used to create flexbox layouts.
 *
 * It renders a `div` with `display: flex` and
 * comes with helpful style shorthand.
 *
 * @see Docs https://chakra-ui.com/flex
 */
exports.Flex = (0, system_1.forwardRef)((props, ref) => {
    const { direction, align, justify, wrap, basis, grow, shrink } = props, rest = __rest(props, ["direction", "align", "justify", "wrap", "basis", "grow", "shrink"]);
    const styles = React.useMemo(() => ({
        display: "flex",
        flexDirection: direction,
        alignItems: align,
        justifyContent: justify,
        flexWrap: wrap,
        flexBasis: basis,
        flexGrow: grow,
        flexShrink: shrink,
    }), [direction, align, justify, wrap, basis, grow, shrink]);
    return React.createElement(system_1.chakra.div, Object.assign({ ref: ref, __css: styles }, rest));
});
if (utils_1.__DEV__) {
    exports.Flex.displayName = "Flex";
}
//# sourceMappingURL=MyFlex.js.map